unit udmdemoruntime;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, SQLite3Conn, SQLDBLib, SQLDB, Forms, uguessfile, dialogs ;

const
  {$include demosqlite.Inc}

type

  { Tdmdemoruntime }

  Tdmdemoruntime = class(TDataModule)
    SQLConnector1: TSQLConnector;
    SQLiteConnection:TSQLite3Connection;
    SQLDBLibraryLoader1: TSQLDBLibraryLoader;
    SQLScript1: TSQLScript;
    SQLTransaction1: TSQLTransaction;
    procedure DataModuleCreate(Sender: TObject);
    procedure DataModuleDestroy(Sender: TObject);
  private

  public
    procedure ImportData;
    procedure OpenConnection;
    procedure CloseConnection;
  end;

var
  dmdemoruntime: Tdmdemoruntime;

implementation

{$R *.lfm}

{ Tdmdemoruntime }

procedure Tdmdemoruntime.DataModuleCreate(Sender: TObject);
var
  sLibrary:string;
  sSQLfile:string;
  sSearched:string;
  sPathstring:string;
begin
  try
{
    sLibrary :='';
    sLibrary := GuessLibraryLocation;              //Search for sqlite Library
    if sLibrary = cUNDEF then exit;               //for security reasons in case the exception fails

    //First: load library
    SQLDBLibraryLoader1:=TSQLDBLibraryLoader.Create(self);
    if SQLDBLibraryLoader1.Enabled then SQLDBLibraryLoader1.Enabled:=false;            //triggers an internal UnloadLibrary
    SQLDBLibraryLoader1.ConnectionType:=cConnectorType; //redefine sqlite in case something was changed
    SQLDBLibraryLoader1.LibraryName:=sLibrary;
    SQLDBLibraryLoader1.Enabled:=true;

 }
    SQLiteConnection:= TSQLite3Connection.Create(self);

    SQLTransaction1 := TSQLTransaction.Create(self);
{
    SQLConnector1 := TSQLConnector.Create(self);
    SQLConnector1.Transaction := SQLTransaction1;
    SQLConnector1.ConnectorType:=cConnectorType;
}
    SQLiteConnection.Transaction:= SQLTransaction1;


    //SQLConnector1.CharSet:= 'UTF8';
    //SQLConnector1.Options:=[scoApplyUpdatesChecksRowsAffected];


  finally
    //;
  end;

{
  //Second: Try to find the SQLite Database file
  //        If it does not exist SQLite creates the named database file automatically
  sSearched:='';

  {$ifdef Unix}
  sPathString:='to define'
  {$else}
  sPathString := 'data@sql';
  {$endif}
  sSQLFile := GuessFile(cSQLDatabaseFile,'data@sql',sSearched);
  if sSQLFile = cUNDEF then begin //create an new one and search again
     showmessage('No database file found - searched in' + LineEnding+ sSearched + LineEnding + ' creating standard database instead');
     sSQLFile:=cSQLDatabaseFile;
  end;

  // only then establish a connection to the database
  SQLConnector1.DatabaseName:=sSQLFile;
  SQLConnector1.ConnectorType:=cConnectorType;
  SQLConnector1.Open;
}
  //Third: Import demo data
  //ImportData; //import demo data

end;

procedure Tdmdemoruntime.DataModuleDestroy(Sender: TObject);
begin
 // if SQLDBLibraryLoader1.Enabled then SQLDBLibraryLoader1.Enabled:=false;
 // if SQLConnector1.Connected then SQLConnector1.Close();
  SQLDBLibraryLoader1.free;
  SQLConnector1.free;
  SQLTransaction1.free;
end;

procedure Tdmdemoruntime.ImportData;
var
  sImportFile:string;
  MyScript:TSQLScript;
  OpenDialog:TOpendialog;
begin
  MyScript:=TSQLScript(self);
  try
    sImportFile := GuessSQLImportFile;
    if sImportFile = cUNDEF then begin //just in case
       showmessage( 'SQL import file not found');

       OpenDialog := TOpendialog.Create(self);
       if OpenDialog.Execute then
       begin
         sImportFile := OpenDialog.Filename;
       end;
    end;

    if sImportFile <> cUNDEF then begin
      MyScript.Script.LoadFromFile(sImportFile);
      MyScript.ExecuteScript;     //oder.Execute???
    end;
  finally
     freeandnil(MyScript);
     freeandnil(OpenDialog);
  end;
end;

procedure Tdmdemoruntime.OpenConnection;
begin
  if not SQLConnector1.Connected then SQLConnector1.Open;
end;

procedure Tdmdemoruntime.CloseConnection;
begin
  if SQLConnector1.Connected then SQLConnector1.Close;
end;

end.

