unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, DB, SQLDB, Forms, Controls, Graphics, Dialogs, StdCtrls,
  DBGrids, ExtCtrls, DBCtrls
  , udmsqldb
  , usqldbruntime
  , udmSQLDBSimple
  ;

const
  cSQLDBGUI        =0;
  cSQLDBRuntime    =1;
  cSQLDBSimple     =2;

type

  { TForm1 }

  TForm1 = class(TForm)
    bttnQuery: TButton;
    bttnImport: TButton;
    bttnConnect: TButton;
    bttnDisconnect: TButton;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    MemoLog: TMemo;
    MemoSQL: TMemo;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    RadioGroup1: TRadioGroup;
    Splitter1: TSplitter;

    SQLQuery1: TSQLQuery;

    procedure bttnConnectClick(Sender: TObject);
    procedure bttnDisconnectClick(Sender: TObject);
    procedure bttnQueryClick(Sender: TObject);
    procedure bttnImportClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
  private
    oSQLDBRuntime:Tsqldbruntime;
    dmSQLDBGUI:Tdmsqldb;
    dmSQLDBSimple:TdmSQLDBSimple;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.bttnQueryClick(Sender: TObject);
begin

   case RadioGroup1.ItemIndex of
     cSQLDBGUI: begin
        {ein komplexeres Datenmodul das versucht alle nötigen Dateien zu finden bzw zu erraten.}
        if dmSQLDBGUI.SQLQuery1.Active then dmSQLDBGUI.SQLQuery1.Close;
        DataSource1.DataSet := dmSQLDBGUI.SQLQuery1;

        dmSQLDBGUI.SQLQuery1.SQL.Text := MemoSQL.Lines.Text;
        dmSQLDBGUI.SQLQuery1.Open;
     end;

     cSQLDBRuntime: begin
        if not assigned(oSQLDBruntime) then oSQLDBruntime:=Tsqldbruntime.Create;
        if SQLQuery1.Active then SQLQuery1.Close;
        SQLQuery1.DataBase := oSQLDBruntime.SQLConnector1;
        SQLQuery1.Transaction:=oSQLDBruntime.SQLTransaction1;
        DataSource1.DataSet := SQLQuery1;
        SQLQuery1.SQL.Text := MemoSQL.Lines.Text;

        if (pos('select', MemoSQL.Lines.Text)=0) and (pos('SELECT', MemoSQL.Lines.Text)=0) then
          SQLQuery1.ExecSQL
        else
          SQLQuery1.Open;
     end;

     cSQLDBSimple: begin
        {ein einfaches Datenmodul mit TSQLite3Connection ohne besondere Funktion.
         Leicht in einem Projekt verwendbar, nur der Datenbankname muss in der GUI angepasst werden und die
         sqlite.dll ins Applikationsverzeichnis kopiert werden.}

        if SQLQuery1.Active then SQLQuery1.Close;
        SQLQuery1.DataBase := dmSQLDBSimple.SQLite3Connection1;
        DataSource1.DataSet := SQLQuery1;
        SQLQuery1.SQL.Text := MemoSQL.Lines.Text;

        if (pos('select', MemoSQL.Lines.Text)=0) and (pos('SELECT', MemoSQL.Lines.Text)=0) then
          SQLQuery1.ExecSQL
        else
          SQLQuery1.Open;
     end;

   else
     showmessage('Connectbutton -> undefined Radio button choice');
   end; //case

end;

procedure TForm1.bttnConnectClick(Sender: TObject);
begin

   case RadioGroup1.ItemIndex of
     cSQLDBGUI: begin
        MemoLog.Clear;
        MemoLog.Append('Connecting...');
        memoLog.Append(dmSQLDBGUI.ListConnectionTypes);

        if not assigned(dmSQLDBGUI) then dmSQLDBGUI:=Tdmsqldb.Create(self);
        MemoLog.Append(LineEnding+'using Library:');
        memoLog.Append(dmSQLDBGUI.SQLDBLibraryLoader1.LibraryName);

        dmSQLDBGUI.SQLConnector1.Connected:=true;;
        if dmSQLDBGUI.SQLConnector1.Connected then memolog.Append('Connected to '+dmSQLDBGUI.SQLConnector1.DatabaseName) ;

        if not dmSQLDBGUI.SQLConnector1.Connected then dmSQLDBGUI.SQLConnector1.Connected:=true;
        if dmSQLDBGUI.SQLConnector1.Connected then memolog.Append(LineEnding+'Database: '+dmSQLDBGUI.SQLConnector1.DatabaseName) ;
        memolog.Append(LineEnding+'SQLite Version: '+dmSQLDBGUI.GetSQLiteVersion);
        memolog.Append(LineEnding+'Connected');

     end;

     cSQLDBRuntime: begin
        MemoLog.Clear;
        MemoLog.Append('Connecting...');
        memoLog.Append(oSQLDBruntime.ListConnectionTypes);

        if not assigned(oSQLDBruntime) then oSQLDBruntime:=Tsqldbruntime.Create;
        MemoLog.Append(LineEnding+'using Library:');
        memoLog.Append(oSQLDBruntime.SQLDBLibraryLoader1.LibraryName);

        if not oSQLDBruntime.SQLConnector1.Connected then oSQLDBruntime.SQLConnector1.Connected:=true;
        if oSQLDBruntime.SQLConnector1.Connected then memolog.Append(LineEnding+'Database: '+oSQLDBruntime.SQLConnector1.DatabaseName) ;
        memolog.Append(LineEnding+'SQLite Version: '+oSQLDBruntime.GetSQLiteVersion);
        memolog.Append(LineEnding+'Connected');

     end;

     cSQLDBSimple: begin
        if not assigned(dmSQLDBSimple) then dmSQLDBSimple:=TdmSQLDBSimple.Create(self);
        if not dmSQLDBSimple.SQLite3Connection1.Connected then dmSQLDBSimple.SQLite3Connection1.Connected:=true;
        if dmSQLDBSimple.SQLite3Connection1.Connected then memolog.Append('Connected to '+dmSQLDBSimple.SQLite3Connection1.DatabaseName) ;
        memolog.Append('SQLite Version: '+dmSQLDBSimple.GetSQLiteVersion);

     end;

   else
     showmessage('Connectbutton -> undefined Radio button choice');
   end; //case

   bttnConnect.Enabled:=false;
   bttnDisconnect.Enabled:=true;
   bttnQuery.Enabled:=true;
   bttnImport.Enabled:=true;
   RadioGroup1.Enabled:=false;

end;

procedure TForm1.bttnDisconnectClick(Sender: TObject);
begin

   case RadioGroup1.ItemIndex of
     cSQLDBGUI: begin
        if not assigned(dmSQLDBGUI) then exit;
        dmSQLDBGUI.SQLConnector1.Connected:=false;
        if not dmSQLDBGUI.SQLConnector1.Connected then memolog.Append('Disconnected ') ;
        freeandnil(dmSQLDBGUI);
     end;

     cSQLDBRuntime: begin
        if not assigned(oSQLDBRuntime) then exit;
        oSQLDBRuntime.SQLConnector1.Connected:=false;
        if not oSQLDBRuntime.SQLConnector1.Connected then memolog.Append('Disconnected ') ;
        freeandnil(oSQLDBruntime);
     end;

     cSQLDBSimple: begin
        if not assigned(dmSQLDBSimple) then exit;
        dmSQLDBSimple.SQLite3Connection1.Connected:=false;
        if not dmSQLDBSimple.SQLite3Connection1.Connected then memolog.Append('Disconnected ') ;
        freeandnil(dmSQLDBSimple);
     end;

   else
     showmessage('Connectbutton -> undefined Radio button choice');
   end; //case


   bttnConnect.Enabled:=true;
   bttnDisconnect.Enabled:=false;
   bttnQuery.Enabled:=false;
   bttnImport.Enabled:=false;
   RadioGroup1.Enabled:=true;
end;

procedure TForm1.bttnImportClick(Sender: TObject);

var
  sImportFile:string;
  OpenDialog:TOpendialog;
  s:string;
begin
   MemoLog.Append('Importing data, please wait...');

   case RadioGroup1.ItemIndex of
     cSQLDBGUI: begin
        if SQLQuery1.Active then SQLQuery1.Close;

        dmSQLDBGUI.ImportData;
        s:='dmSQLDBGUI';
     end;

     cSQLDBRuntime: begin
        if SQLQuery1.Active then SQLQuery1.Close;
        oSQLDBRuntime.ImportData;
        s:='oSQLDBRuntime';
     end;

     cSQLDBSimple: begin
        if SQLQuery1.Active then SQLQuery1.Close;
        dmSQLDBSimple.ImportData;
        s:='dmSQLDBSimple';
     end;

   else
     showmessage('Importbutton -> undefined Radio button choice');
   end; //case
   MemoLog.Append(LineEnding+s+': Import was done');

end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  freeandnil(oSQLDBruntime);
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
var
  s:string;
begin
  if SQLQuery1.Active then SQLQuery1.Close;
  if assigned(dmSQLDBGUI) then dmSQLDBGUI.CloseConnection;
  if assigned(oSQLDBRuntime) then oSQLDBRuntime.CloseConnection;
  if assigned(dmSQLDBSimple) then
         if dmSQLDBSimple.SQLite3Connection1.Connected then dmSQLDBSimple.SQLite3Connection1.Close(true);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   RadioGroup1.Items.Clear;
   RadioGroup1.Items.Append('SQLDB GUI');
   RadioGroup1.Items.Append('SQLDB Runtime');
   RadioGroup1.Items.Append('SQLDB Simple');
   RadioGroup1.ItemIndex:=cSQLDBGUI;

end;


end.

